#
# Belady-Lehman-fishing.R,  8 Jan 24
#
# Data from:
# The Characteristics of Large Systems
# by Belady and Lehman


par(bty="l")
par(las=1)
par(pch="+")


bl=read.csv("Belady-Lehman-sh.csv")

plot(~ DSLOC+doc_pages+man_mon, data=bl, log="xy", col="salmon", cex=1.5)

dev.copy(dev=png, file="large-proj-doc-mm.png")
dev.off()


mm_mod=glm(log(man_mon) ~ log(DSLOC)+log(doc_pages), data=bl)
summary(mm_mod, correlation=TRUE)

# Call:
# glm(formula = log(man_mon) ~ log(DSLOC) + log(doc_pages), data = bl)
# 
# Deviance Residuals: 
#      Min        1Q    Median        3Q       Max  
# -1.37836  -0.42801  -0.09721   0.35843   1.68757  
# 
# Coefficients:
#                Estimate Std. Error t value Pr(>|t|)    
# (Intercept)    -5.02314    1.01184  -4.964 2.58e-05 ***
# log(DSLOC)      0.80139    0.13408   5.977 1.49e-06 ***
# log(doc_pages)  0.25276    0.09489   2.664   0.0123 *  
# ---
# Signif. codes:  0 ‘***’ 0.001 ‘**’ 0.01 ‘*’ 0.05 ‘.’ 0.1 ‘ ’ 1
# 
# (Dispersion parameter for gaussian family taken to be 0.492074)
# 
#     Null deviance: 83.442  on 32  degrees of freedom
# Residual deviance: 14.762  on 30  degrees of freedom
#   (4 observations deleted due to missingness)
# AIC: 75.104
# 
# Number of Fisher Scoring iterations: 2
# 
# Correlation of Coefficients:
#                (Intercept) log(DSLOC)
# log(DSLOC)     -0.86                 
# log(doc_pages)  0.28       -0.73     
# 

loc_mod=glm(log(man_mon) ~ log(DSLOC), data=bl)
summary(loc_mod)

doc_mod=glm(log(man_mon) ~ log(doc_pages), data=bl)
summary(doc_mod)


# dc_mod=glm(doc_pages ~ DSLOC, data=bl)
dc_mod=glm(log(doc_pages) ~ log(DSLOC), data=bl)
summary(dc_mod)


library("car")

vif(mm_mod)

# Well within bounds
#    log(DSLOC) log(doc_pages) 
#      2.116353       2.116353 


